#!/usr/bin/env python2
# -*- encoding=utf-8 -*-
import sys
from dueros.Bot import Bot
from dueros.card.TextCard import TextCard
import urllib2,json
import dueros.paho.mqtt.client as mqtt
reload(sys)
sys.setdefaultencoding('utf8')

class DuerOSBot(Bot):

   def launch_request(self):
       """
       打开技能
       """
       self.wait_answer()
       card = TextCard('欢迎使用智能净化器技能')
       return {
           'card': card,
           'outputSpeech': r'欢迎使用智能净化器技能'
       }

   def ended_request(self):
       """
       关闭技能
       """
       self.wait_answer()
       return {
           'outputSpeech': r'感谢您的使用'
       }

   def __init__(self, request_data):
       super(DuerOSBot, self).__init__(request_data)
       self.add_launch_handler(self.launch_request)
       self.add_session_ended_handler(self.ended_request)
       self.add_intent_handler('open', self.open_intent)
       self.add_intent_handler('close_me', self.close_me_intent)
       self.add_intent_handler('speed', self.speed_intent)
       self.add_intent_handler('Anion', self.Anion_intent)
       self.add_intent_handler('intelligence', self.intelligence_intent)
       self.add_intent_handler('disinfect', self.disinfect_intent)
       self.add_intent_handler('time', self.time_intent)
       self.add_intent_handler('sleep', self.sleep_intent)
   def open_intent(self):
        on_publish("5n92uqBMg", "0", 0)#0代表保存在服务器上
        card = TextCard('已为您打开净化器')
        return {
           'card': card,
           'outputSpeech': r'已为您打开净化器'
        }
   def close_me_intent(self):
        on_publish("5n92uqBMg", "0", 0)#0代表保存在服务器上
        card = TextCard('已为您关闭净化器')
        return {
           'card': card,
           'outputSpeech': r'已为您关闭净化器'
        }
   def speed_intent(self):
        on_publish("5n92uqBMg", "1", 0)#0代表保存在服务器上
        card = TextCard('已为您调整净化速度')
        return {
           'card': card,
           'outputSpeech': r'已为您调整净化速度'
        }
   def Anion_intent(self):
        on_publish("5n92uqBMg", "2", 0)#0代表保存在服务器上
        card = TextCard('已为您开启负离子')
        return {
           'card': card,
           'outputSpeech': r'已为您开启负离子'
        }
   def intelligence_intent(self):
        on_publish("5n92uqBMg", "3", 0)#0代表保存在服务器上
        card = TextCard('已为您开启智能模式')
        return {
           'card': card,
           'outputSpeech': r'已为您开启智能模式'
        }
   def disinfect_intent(self):
        on_publish("5n92uqBMg", "4", 0)#0代表保存在服务器上
        card = TextCard('已为您开启杀菌模式')
        return {
           'card': card,
           'outputSpeech': r'已为您开启杀菌模式'
        }
   def time_intent(self):
        on_publish("5n92uqBMg", "5", 0)#0代表保存在服务器上
        card = TextCard('已为您开启定时')
        return {
           'card': card,
           'outputSpeech': r'已为您开启定时'
        }
   def sleep_intent(self):
        on_publish("5n92uqBMg", "6", 0)#0代表保存在服务器上
        card = TextCard('已为您开启睡眠模式')
        return {
           'card': card,
           'outputSpeech': r'已为您开启睡眠模式'
        }
MQTTHOST = "182.254.130.180"
MQTTPORT = 1883
mqttClient = mqtt.Client()
 
 
# 连接MQTT服务器
def on_mqtt_connect():
   mqttClient.connect(MQTTHOST, MQTTPORT, 60)
   mqttClient.loop_start()
 
 
# publish 消息
def on_publish(topic, payload, qos):
   mqttClient.publish(topic, payload, qos)
   #print(topic)
 
# 消息处理函数
def on_message_come(lient, userdata, msg):
   pass
   #print(msg.topic + " " + ":" + str(msg.payload))
 
 
# subscribe 消息
def on_subscribe():
   mqttClient.subscribe("5n92uqBMg", 1)
   mqttClient.on_message = on_message_come # 消息到来处理函数
def handler(event, context):
   on_mqtt_connect()
   bot = DuerOSBot(event)
   result = bot.run()
   return result